/******************************************************************************
* FILE: omp_getEnvInfo.c
* DESCRIPCION: OPENMP: manejo de informacion de entorno
******************************************************************************/

#include <omp.h>
#include <stdio.h>
#include <stdlib.h>

int main (int argc, char *argv[]) 
{
int nthreads, tid, procs, maxt, inpar, dynamic, nested;

#pragma omp parallel private(nthreads, tid)
  {

  tid = omp_get_thread_num();

  if (tid == 0) 
    {
    printf("Thread %d oteniendo informacion de entorno..\n", tid);

    procs = omp_get_num_procs();
    nthreads = omp_get_num_threads();
    maxt = omp_get_max_threads();
    inpar = omp_in_parallel();
    dynamic = omp_get_dynamic();
    nested = omp_get_nested();

    printf("Numbero de procesos = %d\n", procs);
    printf("Numbero de threads = %d\n", nthreads);
    printf("Maximo N de threads = %d\n", maxt);
    printf("In_parallel? = %d\n", inpar);
    printf("Dynamic_threads_enabled? = %d\n", dynamic);
    printf("Nested_parallelism_enabled? = %d\n", nested);

    }

  }  /* Fin */


}

