#include <omp.h>

#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdio.h>
#include <stdlib.h>

#include <conio.h>

#include <string.h>
#include <math.h>


#include "time.h"
#define GETTIME( A ) A = ((double)clock()/CLOCKS_PER_SEC);

double funcion(double a)
{
	double b=0;
	for (int i=0; i<100; i++)
	{
		b += a;
		b = sqrt(b);
	}
	return b;
}

int main(int argc, char* argv[])
{
	// Leer numThreads
	int numThread=4,N= 1000000;
    double t0,t1,wtime;
	double *vec1, *vec2,*vecRes ;
	double v1, v2;
	int i,k;
	omp_set_num_threads(numThread);
	
	vec1 = (double *)malloc(N*sizeof(double));
	vec2 = (double *)malloc(N*sizeof(double));
	vecRes = (double *)malloc(N*sizeof(double));

	for (k=0; k < N; k++){
	   vec1[k]=0.0;
	   vec2[k]=0.0;
	   vecRes[k]=0.0;
	}

	#pragma omp parallel
	{
		// This statement will run on each thread.
		// If there are 4 threads, this will execute 4 times in total
		printf("Running on multiple threads\n");
	}

       
	wtime = omp_get_wtime ( );

	GETTIME(t0);
	for (k=0; k < 100; k++)
	{
		# pragma omp parallel for private(i, v1, v2)
		for (i=0; i < N; i++)
		{
			v1 = vec1[i];
			v2 = vec2[i];
			vecRes[i] = v1 * v2;
		}
	}
	GETTIME(t1);
	wtime = omp_get_wtime ( )-wtime;
	printf("Tiempo Combinación lineal: %f %f sec \n", t1 - t0, wtime);


	GETTIME(t0);
	wtime = omp_get_wtime ( );

	# pragma omp parallel for private(i, v1, v2)
	for (i=0; i < N; i++)
	{
			v1 = (double)i;
			v1 = sqrt(v1);
	}
	GETTIME(t1);
     wtime = omp_get_wtime ( )-wtime;

	printf( "Tiempo Raiz Cuadrada: %f  %f sec \n", t1 - t0,wtime);

	GETTIME(t0);
    wtime = omp_get_wtime ( );

	# pragma omp parallel for private(i, v1)
	for (i=0; i < N; i++)
	{
			v1 = (double)i;
			v1 = pow(v1, 5);
	}
	GETTIME(t1);
    wtime = omp_get_wtime ( )-wtime;
    printf("Tiempo Potencia: %f %f sec \n", t1 - t0,wtime);

	GETTIME(t0);
    wtime = omp_get_wtime ( );

	# pragma omp parallel for private(i, v1)
	for (i=0; i < N; i++)
	{
			v1 = funcion((double)i);
			v1 = pow(v1, 5);
	}
	GETTIME(t1);
    wtime = omp_get_wtime ( )-wtime;
 	printf("Tiempo Funcion: %f %f sec \n", t1 - t0, wtime);

	getch();

	return 0;

}
