#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define MAXI 4

typedef float MATRIX[MAXI][MAXI];


main()
{
    MATRIX  A;
    float     x[MAXI],b[MAXI],tolera=0.000001;
    int       n=MAXI,itera=50,converge,k;

    void GeneraMyV(MATRIX A,float *b);
    int Jacobi(MATRIX A, float *x, float *b, int n,float tolera, int itera);


    printf("Resolucion de un sistema de %ix%i por Jacobi\n",MAXI,MAXI);
    printf("Tolerancia: %f ; Iteraciones: %i \n",tolera,itera);

    GeneraMyV(A,b);

    converge = Jacobi(A, x, b, n, tolera, itera);

    if (converge!=0)
    {
        printf("La solucion del paso %i es:\n",converge);
        for(k=0;k<n;k++)
            printf("%f\n", x[k]);
    }
    else
        printf("Fallo la convergencia en la iteracion\n", itera);
}

int Jacobi(MATRIX A,float *x,float *b,int n,float tolera,int itera)
{
    int    i,j,cont=0;
    float  x_viejo[MAXI];

    float Distancia(float *x, float *y, int n);

    for (i = 0; i < n; i++)
    {
        x[i] = b[i];
        x_viejo[i]=0.0 ;
    }

    while ((cont < itera) && (Distancia(x,x_viejo,n) >= tolera))
    {
        cont++;

        for (i = 0; i < n; i++)
            x_viejo[i] = x[i];

        for (i = 0; i < n; i++)
        {
            x[i] = b[i];
            for (j = 0; j < i; j++)
                x[i] = x[i] - A[i][j]*x_viejo[j];
            for (j = i+1; j < n; j++)
                x[i] = x[i] - A[i][j]*x_viejo[j];
            x[i] = x[i]/A[i][i];
        }
    }

    if (Distancia(x,x_viejo,n) < tolera)
        return cont;
    else
        return 0;
}

float Distancia(float *x, float *y, int n)
{
    int i;
    float suma = 0.0;

    for(i=0;i<n;i++)
        suma = suma + fabs((x[i] - y[i]));//*(x[i] - y[i]);

    //return sqrt(suma);
    return suma/(float)n;
}

void GeneraMyV(MATRIX A,float *b)
{
  int k,j;
  FILE *in;

   in=fopen("datos.txt","r+");

 
    for(k=0;k<MAXI;k++)
    {
         fscanf(in,"%f\n",&b[k]);
   	 printf("v:%i %f\n",k,b[k]);
         for(j=0;j<MAXI;j++)
         {
           fscanf(in,"%f\n",&A[k][j]);
//este paso es para asegurar que la matriz sea diagonal dominante
           if(j==k)  A[k][k]=A[k][k]*10;
           printf("M:%i %i %f\n",k,j,A[k][j]);
         }     
     }
 fclose(in);


}
