/******************************************************************************
* FILE: omp_matrizpormatriz.c
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#include <conio.h>

#define NRA 62                 /* numbero de filas en matrix A */
#define NCA 15                 /* numbero de columnas en matrix A */
#define NCB 7                  /* numbero de columnas en matrix B */

int main (int argc, char *argv[]) 
{
int	 i, j, k;
double	a[NRA][NCA],           /* matrix A a ser multiplicada */
	b[NCA][NCB],           /* matrix B a ser multiplicada */
	c[NRA][NCB];           /* resultado en  matrix C */

printf("Comienzo del matriz por matriz example\n");
printf("Inicializo matrices...\n");


  #pragma omp for private(i)
for (i=0; i<NRA; i++)
    for (j=0; j<NCA; j++)
      a[i][j]= i+j;

#pragma omp for private(i)
for (i=0; i<NCA; i++)
    for (j=0; j<NCB; j++)
      b[i][j]= i*j;

#pragma omp for private(i)
for (i=0; i<NRA; i++)
    for (j=0; j<NCB; j++)
      c[i][j]= 0;

  /*** Se realiza la multiplicacion de la matriz compartiendo las iteraciones de loop externo ***/

printf("comienza la multiplciacion...\n");

#pragma omp for private(i)
for (i=0; i<NRA; i++)    
{
    for(j=0; j<NCB; j++)       
      for (k=0; k<NCA; k++)
        c[i][j] += a[i][k] * b[k][j];
}

/*** Imprime resultados ***/
printf("******************************************************\n");
printf("Matrix C:\n");
for (i=0; i<NRA; i++)
  {
  for (j=0; j<NCB; j++) 
    printf("%6.2f   ", c[i][j]);
  printf("\n"); 
  }
printf("******************************************************\n");
printf ("fin.\n");

getch();

}
