#include <stdio.h>
#include <math.h>
#include <malloc.h>

float producto_escalar(float *vector_x, float *vector_y, int n);
void producto_matriz_vector(float **matriz, float* vector, int n, float* producto);
void producto_vector_escalar(float *vector_x, float escalar, int n, float* producto);
void suma_vectores(float *vector_x, float *vector_y, int n, float *suma);
void resta_vectores(float *vector_x, float *vector_y, int n, float *resta);

int main(int argc,char* argv[])
{
	float **matriz_a;
	float *vector_b;
	float *vector_x;
	float *vector_r;
	float *vector_v;
	float *vector_z;
	float *vector_aux;
	float c,t,d;
	int n,M,k,i;
	char filenameIn[80],filenameOut[80];
	FILE *stream;
	
	printf("Archivo de entrada: ");scanf("%s",filenameIn);
	printf("Archivo de salida: ");scanf("%s",filenameOut);
	printf("Maximo de iteraciones: ");scanf("%d",&M);

	stream = fopen(filenameIn, "r" );
	if( stream == NULL )
		printf( "Imposible abrir el archivo de entrada\n" );
	else
	{
		//Leer la matriz y el vector b desde el archivo
		fscanf(stream,"%d",&n);
		matriz_a = (float **) malloc(n*sizeof(float*));
		vector_b = (float *) malloc(n*sizeof(float));
		vector_x = (float *) malloc(n*sizeof(float));
		vector_r = (float *) malloc(n*sizeof(float));
		vector_v = (float *) malloc(n*sizeof(float));
		vector_z = (float *) malloc(n*sizeof(float));
		vector_aux = (float *) malloc(n*sizeof(float));
		for (i = 0; i < n ; i++)
		{
			matriz_a[i] = (float *) malloc(n*sizeof(float));
			for (k = 0; k < n; k++)
			{
				fscanf(stream,"%f",&matriz_a[i][k]);
			}
		}
		for (i = 0; i < n ; i++)
		{
			fscanf(stream,"%f",&vector_b[i]);
			vector_x[i] = 0;
		}
		fclose(stream);
		


		//Algoritmo de gradientes conjugados
		producto_matriz_vector(matriz_a,vector_x,n,vector_aux);
		resta_vectores(vector_b,vector_aux,n,vector_r);
		resta_vectores(vector_b,vector_aux,n,vector_v);
		c = producto_escalar(vector_r,vector_r,n);
		for (k = 0; k < n; k++)
		{
			if (sqrt(producto_escalar(vector_v,vector_v,n)) < 0.000001) break;
			producto_matriz_vector(matriz_a,vector_v,n,vector_z);
			t = c / producto_escalar(vector_v,vector_z,n);
			producto_vector_escalar(vector_v,t,n,vector_aux);
			suma_vectores(vector_x,vector_aux,n,vector_x);
			producto_vector_escalar(vector_z,t,n,vector_aux);
			resta_vectores(vector_r,vector_aux,n,vector_r);
			d = producto_escalar(vector_r,vector_r,n); 
			if (pow(d,2) < 0.000001) break;
			producto_vector_escalar(vector_v,d/c,n,vector_aux);
			suma_vectores(vector_r,vector_aux,n,vector_v);
			c = d;
		}
		//Guardar el resultado en un archivo
		stream = fopen(filenameOut, "w+" );
		if( stream != NULL )
		{
			fprintf(stream,"Numero de iteraciones: %d \n",k);
			for (i = 0; i < n ; i++)
			{
				fprintf(stream,"%f ",vector_x[i]);
			}
		}
		else
			printf( "Imposible abrir el archivo de salida\n" );
		fclose(stream);

		//Liberar el espacio en memoria
		for (i = 0; i < n ; i++)
		{
			free(matriz_a[i]);
		}
		free(matriz_a);
		free(vector_b);
		free(vector_x);
		free(vector_r);
		free(vector_v);
		free(vector_z);
		free(vector_aux);
	}
}

float producto_escalar(float *vector_x, float *vector_y, int n)
{
	float sumatoria;
	int i;
	sumatoria  = 0;
	for (i = 0; i < n; i++)
		sumatoria = sumatoria + (vector_x[i] * vector_y[i]);
	return sumatoria;
}

void producto_matriz_vector(float **matriz, float* vector, int n, float* producto)
{
	int i;
	for (i = 0; i < n; i++)
	{
		producto[i] = producto_escalar(matriz[i],vector,n);
	}
}

void producto_vector_escalar(float *vector_x, float escalar, int n, float* producto)
{
	int i;
	for (i = 0; i < n; i++)
	{
		producto[i] = vector_x[i] * escalar;
	}
}

void suma_vectores(float *vector_x, float *vector_y, int n, float *suma)
{
	int i;
	for (i = 0; i < n; i++)
	{
		suma[i] = vector_x[i] + vector_y[i];
	}
}

void resta_vectores(float *vector_x, float *vector_y, int n, float *resta)
{
	int i;
	for (i = 0; i < n; i++)
	{
		resta[i] = vector_x[i] - vector_y[i];
	}
}
